#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setAutoReboot.cgi,v 1.1 2009/04/24 23:50:19 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/setAutoReboot.cgi,v $

########################################################################
# setAutoReboot.cgi
#
# CGI script to implement the setting of the AutoReboot limit.
# Called from perl-scripts/reset.cgi with parameters like this:
#
#   setAutoReboot.cgi?autoRebootEnable=1&autoRebootLimit=10
#
# In response, this script parses the parameters, updates the 
# autoReboot configuration file, puts up an "Okay, I did it" message,
# and then switches back to the rconfigDisplay page.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set AutoReboot' ) ;

#print( '<br/>Parameters Received:<br/>' ) ;
#foreach my $p (param())
#{
#    print( "$p=", param($p), '<br/>' ) ;
#}
#print '<br/>' ;


# Read the current AutoReboot limit.  Default to zero == off.
my $configFile = '/etc/sysconfig/autoReboot' ;
my $autoRebootLimit = 0 ;
if ( -f $configFile )
{
  $autoRebootLimit = qx( cat $configFile ) ;
}
  

# Determine new limit in Hours.  Default to zero == off.
my $newAutoRebootLimit = 0 ;
if ( param( 'autoRebootEnable' ) )
{
  $newAutoRebootLimit = param( 'autoRebootLimit' ) ; 
}

# If an AutoReboot reset has been requested, do it.
if ( param( 'autoRebootReset' ) == 1 )
{
  print( h2( 'Restarting AutoReboot timer.' ) ) ;
}

# If the new limit (or disable) is different from the existing
# one, update the configuration file.
if ( $newAutoRebootLimit * 3600 != $autoRebootLimit)
{
  print( h2( ($newAutoRebootLimit != 0 )
             ? "Setting limit to $newAutoRebootLimit hours" 
             : "Disabling AutoReboot." 
           ) 
       ) ;

  saveAutoRebootLimit( $newAutoRebootLimit * 3600 ) ;
}

# Regardless of which type of request has come in, restart the
# timer in frontpanel_task.
autoRebootReset() ;

print <<EOF;
     <Script>
     parent.loadAfterDelay( 'rconfigDisplay.cgi', 1000) ;
     </Script>
EOF

print end_html() ;

########################################################################
# end of file setAutoReboot.cgi
########################################################################
